
function [x1_nn, x2_nn] = nn_impute(x1, x2, feature, hdist, hdistparam)

if nargin < 4
    hdist = @util_dist2;
end

dp = feature(:,1);
dq = feature(:,2);
dr = feature(:,3);

x1_nn = x1;

for ii=1:1000:size(x1_nn,1)
    cellidx = ii:min(ii+1000-1, size(x1_nn,1));
    
    ds = hdist(x1_nn(cellidx,dp), x2(:,dp));
    
    [temp, dsidx] = min(ds,[],2);
    x1_nn(cellidx,dr) = x2(dsidx,dr);
end

if (nargout>1)
    x2_nn = x2;
    
    for ii=1:1000:size(x2_nn,1)
        cellidx = ii:min(ii+1000-1, size(x2_nn,1));

        ds = hdist(x2_nn(cellidx,dp), x1(:,dp));

        [temp, dsidx] = min(ds,[],2);
        x2_nn(cellidx,dq) = x1(dsidx,dq);
    end
end
